Index: trunk/src/kernel32/lang.cpp
===================================================================
--- trunk/src/kernel32/lang.cpp	(revision 2802)
+++ trunk/src/kernel32/lang.cpp	(revision 2803)
@@ -1,2 +1,3 @@
+/* $Id: lang.cpp,v 1.17 2000-02-16 14:27:07 sandervl Exp $ */
 /*
  * Win32 language API functions for OS/2
Index: trunk/src/kernel32/network.cpp
===================================================================
--- trunk/src/kernel32/network.cpp	(revision 2802)
+++ trunk/src/kernel32/network.cpp	(revision 2803)
@@ -1,2 +1,3 @@
+/* $Id: network.cpp,v 1.9 2000-02-16 14:27:08 sandervl Exp $ */
 /*
  * Win32 Network apis
Index: trunk/src/kernel32/npipe.cpp
===================================================================
--- trunk/src/kernel32/npipe.cpp	(revision 2802)
+++ trunk/src/kernel32/npipe.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: npipe.cpp,v 1.6 2000-02-10 22:39:46 bird Exp $ */
+/* $Id: npipe.cpp,v 1.7 2000-02-16 14:25:43 sandervl Exp $ */
 /*
  * Win32 Named pipes API
@@ -17,4 +17,7 @@
 #include "debugtools.h"
 #include "oslibdos.h"
+
+#define DBG_LOCALLOG	DBG_npipe
+#include "dbglocal.h"
 
 ODINDEBUGCHANNEL(KERNEL32-NPIPE)
Index: trunk/src/kernel32/obsolete.cpp
===================================================================
--- trunk/src/kernel32/obsolete.cpp	(revision 2802)
+++ trunk/src/kernel32/obsolete.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: obsolete.cpp,v 1.2 1999-06-10 19:09:35 phaller Exp $ */
+/* $Id: obsolete.cpp,v 1.3 2000-02-16 14:25:43 sandervl Exp $ */
 
 /*
@@ -12,4 +12,7 @@
 #include <os2win.h>
 
+#define DBG_LOCALLOG	DBG_obsolete
+#include "dbglocal.h"
+
 //Api's that are obsolete, but some apps might still reference them
 //(the Red Alert AUTORUN.EXE does)
Index: trunk/src/kernel32/os2heap.cpp
===================================================================
--- trunk/src/kernel32/os2heap.cpp	(revision 2802)
+++ trunk/src/kernel32/os2heap.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: os2heap.cpp,v 1.13 1999-11-18 09:21:34 bird Exp $ */
+/* $Id: os2heap.cpp,v 1.14 2000-02-16 14:25:43 sandervl Exp $ */
 
 /*
@@ -28,4 +28,7 @@
 #include "initterm.h"
 
+#define DBG_LOCALLOG	DBG_os2heap
+#include "dbglocal.h"
+
 #ifndef HEAP_NO_SERIALIZE
   #define HEAP_NO_SERIALIZE 1
Index: trunk/src/kernel32/oslibdebug.cpp
===================================================================
--- trunk/src/kernel32/oslibdebug.cpp	(revision 2802)
+++ trunk/src/kernel32/oslibdebug.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: oslibdebug.cpp,v 1.1 1999-12-31 10:47:11 sandervl Exp $ */
+/* $Id: oslibdebug.cpp,v 1.2 2000-02-16 14:25:44 sandervl Exp $ */
 
 /*
@@ -27,4 +27,7 @@
 #include "oslibdebug.h"
 
+#define DBG_LOCALLOG	DBG_oslibdebug
+#include "dbglocal.h"
+
 #define DEBUG_QUEUENAME "\\QUEUES\\ODINTRACE\\"
 #define DEBUG_QSEMNAME  "\\SEM32\\ODINTRACEQ\\"
Index: trunk/src/kernel32/oslibdos.cpp
===================================================================
--- trunk/src/kernel32/oslibdos.cpp	(revision 2802)
+++ trunk/src/kernel32/oslibdos.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: oslibdos.cpp,v 1.18 2000-02-08 22:29:15 sandervl Exp $ */
+/* $Id: oslibdos.cpp,v 1.19 2000-02-16 14:25:45 sandervl Exp $ */
 /*
  * Wrappers for OS/2 Dos* API
@@ -27,4 +27,7 @@
 #include "dosqss.h"
 
+#define DBG_LOCALLOG	DBG_oslibdos
+#include "dbglocal.h"
+
 /***********************************
  * PH: fixups for missing os2win.h *
@@ -344,4 +347,5 @@
 }
 //******************************************************************************
+DWORD WIN32API GetEnvironmentVariableA(LPCSTR, LPSTR, DWORD );
 //******************************************************************************
 DWORD OSLibDosSearchPath(DWORD cmd, char *path, char *name, char *full_name, 
@@ -377,14 +381,17 @@
   case OSLIB_SEARCHENV:
   {
-   PCSZ envstring;
-   CHAR szResult[CCHMAXPATH];
-
-	if(DosScanEnv(path, &envstring) != 0) {
+   LPSTR envstring;
+   int   envsize;
+   CHAR  szResult[CCHMAXPATH];
+
+	envsize = GetEnvironmentVariableA(path, NULL, 0);
+	envstring = (LPSTR)malloc(envsize+1);
+	GetEnvironmentVariableA(path, envstring, envsize);
+	if(DosSearchPath(SEARCH_IGNORENETERRS, envstring,
+                         name, szResult, sizeof(szResult)) != 0) {
+		free(envstring);
 		return 0;
 	}
-	if(DosSearchPath(SEARCH_IGNORENETERRS, envstring,
-                         name, szResult, sizeof(szResult)) != 0) {
-		return 0;
-	}
+	free(envstring);
 	strcpy(full_name, szResult);
 	return strlen(full_name);
Index: trunk/src/kernel32/oslibexcept.cpp
===================================================================
--- trunk/src/kernel32/oslibexcept.cpp	(revision 2802)
+++ trunk/src/kernel32/oslibexcept.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: oslibexcept.cpp,v 1.1 1999-10-09 15:03:23 sandervl Exp $ */
+/* $Id: oslibexcept.cpp,v 1.2 2000-02-16 14:25:45 sandervl Exp $ */
 /*
  * Exception handler util. procedures
@@ -19,4 +19,7 @@
 #include <exceptions.h>
 
+#define DBG_LOCALLOG	DBG_oslibexcept
+#include "dbglocal.h"
+
 //******************************************************************************
 //Dispatches OS/2 exception to win32 handler
Index: trunk/src/kernel32/oslibmisc.cpp
===================================================================
--- trunk/src/kernel32/oslibmisc.cpp	(revision 2802)
+++ trunk/src/kernel32/oslibmisc.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: oslibmisc.cpp,v 1.5 2000-01-03 21:36:11 sandervl Exp $ */
+/* $Id: oslibmisc.cpp,v 1.6 2000-02-16 14:25:45 sandervl Exp $ */
 
 /*
@@ -24,4 +24,7 @@
 #include <misc.h>
 
+#define DBG_LOCALLOG	DBG_oslibmisc
+#include "dbglocal.h"
+
 /***********************************
  * PH: fixups for missing os2win.h *
Index: trunk/src/kernel32/resource.cpp
===================================================================
--- trunk/src/kernel32/resource.cpp	(revision 2802)
+++ trunk/src/kernel32/resource.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: resource.cpp,v 1.14 2000-01-05 19:39:56 sandervl Exp $ */
+/* $Id: resource.cpp,v 1.15 2000-02-16 14:25:45 sandervl Exp $ */
 
 /*
@@ -17,4 +17,7 @@
 #include <winexebase.h>
 #include <windllbase.h>
+
+#define DBG_LOCALLOG	DBG_resource
+#include "dbglocal.h"
 
 //******************************************************************************
Index: trunk/src/kernel32/stubs.cpp
===================================================================
--- trunk/src/kernel32/stubs.cpp	(revision 2802)
+++ trunk/src/kernel32/stubs.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: stubs.cpp,v 1.18 2000-01-02 22:51:12 sandervl Exp $ */
+/* $Id: stubs.cpp,v 1.19 2000-02-16 14:25:45 sandervl Exp $ */
 
 /*
@@ -23,4 +23,7 @@
 
 #include "stubs.h"
+
+#define DBG_LOCALLOG	DBG_stubs
+#include "dbglocal.h"
 
 
Index: trunk/src/kernel32/unicode.cpp
===================================================================
--- trunk/src/kernel32/unicode.cpp	(revision 2802)
+++ trunk/src/kernel32/unicode.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: unicode.cpp,v 1.21 2000-01-06 20:07:10 sandervl Exp $ */
+/* $Id: unicode.cpp,v 1.22 2000-02-16 14:25:45 sandervl Exp $ */
 
 /*
@@ -19,4 +19,7 @@
 #include "codepage.h"
 #include <unicode.h>
+
+#define DBG_LOCALLOG	DBG_unicode
+#include "dbglocal.h"
 
 /*static UconvObject uconv_object = NULL;*/
Index: trunk/src/kernel32/wprocess.cpp
===================================================================
--- trunk/src/kernel32/wprocess.cpp	(revision 2802)
+++ trunk/src/kernel32/wprocess.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: wprocess.cpp,v 1.67 2000-02-09 13:42:13 sandervl Exp $ */
+/* $Id: wprocess.cpp,v 1.68 2000-02-16 14:25:46 sandervl Exp $ */
 
 /*
@@ -40,4 +40,6 @@
 #include "mmap.h"
 
+#define DBG_LOCALLOG	DBG_wprocess
+#include "dbglocal.h"
 
 ODINDEBUGCHANNEL(KERNEL32-WPROCESS)
Index: trunk/src/user32/win32class.cpp
===================================================================
--- trunk/src/user32/win32class.cpp	(revision 2802)
+++ trunk/src/user32/win32class.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: win32class.cpp,v 1.13 2000-02-06 22:00:23 sandervl Exp $ */
+/* $Id: win32class.cpp,v 1.14 2000-02-16 14:28:22 sandervl Exp $ */
 /*
  * Win32 Window Class Managment Code for OS/2
@@ -25,4 +25,7 @@
 #include <win\winproc.h>
 
+#define DBG_LOCALLOG	DBG_win32class
+#include "dbglocal.h"
+
 static fDestroyAll = FALSE;
 
Index: trunk/src/user32/win32dlg.cpp
===================================================================
--- trunk/src/user32/win32dlg.cpp	(revision 2802)
+++ trunk/src/user32/win32dlg.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: win32dlg.cpp,v 1.43 2000-02-06 22:00:23 sandervl Exp $ */
+/* $Id: win32dlg.cpp,v 1.44 2000-02-16 14:28:22 sandervl Exp $ */
 /*
  * Win32 Dialog Code for OS/2
@@ -24,4 +24,7 @@
 #include "controls.h"
 #include "syscolor.h"
+
+#define DBG_LOCALLOG	DBG_win32dlg
+#include "dbglocal.h"
 
 #define DEFAULT_DLGFONT "9.WarpSans"
Index: trunk/src/user32/win32wbase.cpp
===================================================================
--- trunk/src/user32/win32wbase.cpp	(revision 2802)
+++ trunk/src/user32/win32wbase.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: win32wbase.cpp,v 1.162 2000-02-15 14:39:12 sandervl Exp $ */
+/* $Id: win32wbase.cpp,v 1.163 2000-02-16 14:28:22 sandervl Exp $ */
 /*
  * Win32 Window Base Class for OS/2
@@ -50,4 +50,7 @@
 #include "timer.h"
 
+#define DBG_LOCALLOG	DBG_win32wbase
+#include "dbglocal.h"
+
 #define SC_ABOUTWINE            (SC_SCREENSAVE+1)
 #define SC_PUTMARK              (SC_SCREENSAVE+2)
Index: trunk/src/user32/win32wbasenonclient.cpp
===================================================================
--- trunk/src/user32/win32wbasenonclient.cpp	(revision 2802)
+++ trunk/src/user32/win32wbasenonclient.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: win32wbasenonclient.cpp,v 1.10 2000-02-10 18:49:52 cbratschi Exp $ */
+/* $Id: win32wbasenonclient.cpp,v 1.11 2000-02-16 14:28:23 sandervl Exp $ */
 /*
  * Win32 Window Base Class for OS/2 (non-client methods)
@@ -39,4 +39,7 @@
 #include <menu.h>
 
+#define DBG_LOCALLOG	DBG_win32wbasenonclient
+#include "dbglocal.h"
+
 #define SC_ABOUTODIN            (SC_SCREENSAVE+1)
 #define SC_PUTMARK              (SC_SCREENSAVE+2)
@@ -957,4 +960,5 @@
 
   dprintf(("DoNCPaint %x %x %d", getWindowHandle(), clip, suppress_menupaint));
+  DecreaseLogCount();
 
   if (!(hdc = GetDCEx( Win32Hwnd, (clip > 1) ? clip : 0, DCX_USESTYLE | DCX_WINDOW |
@@ -1071,4 +1075,5 @@
 
   ReleaseDC(Win32Hwnd,hdc);
+  IncreaseLogCount();
   dprintf(("**DoNCPaint %x DONE", getWindowHandle()));
 }
Index: trunk/src/user32/win32wbasepos.cpp
===================================================================
--- trunk/src/user32/win32wbasepos.cpp	(revision 2802)
+++ trunk/src/user32/win32wbasepos.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: win32wbasepos.cpp,v 1.12 2000-02-03 17:13:03 cbratschi Exp $ */
+/* $Id: win32wbasepos.cpp,v 1.13 2000-02-16 14:28:24 sandervl Exp $ */
 /*
  * Win32 Window Base Class for OS/2 (nonclient/position methods)
@@ -38,4 +38,7 @@
 #include "pmframe.h"
 #include "win32wdesktop.h"
+
+#define DBG_LOCALLOG	DBG_win32wbasepos
+#include "dbglocal.h"
 
 /*******************************************************************
Index: trunk/src/user32/win32wdesktop.cpp
===================================================================
--- trunk/src/user32/win32wdesktop.cpp	(revision 2802)
+++ trunk/src/user32/win32wdesktop.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: win32wdesktop.cpp,v 1.11 2000-02-10 18:49:53 cbratschi Exp $ */
+/* $Id: win32wdesktop.cpp,v 1.12 2000-02-16 14:28:24 sandervl Exp $ */
 /*
  * Win32 Desktop Window for OS/2
@@ -16,4 +16,7 @@
 #include "oslibwin.h"
 #include "win32wndhandle.h"
+
+#define DBG_LOCALLOG	DBG_win32wdesktop
+#include "dbglocal.h"
 
 Win32Desktop *windowDesktop = 0;
Index: trunk/src/user32/win32wmdichild.cpp
===================================================================
--- trunk/src/user32/win32wmdichild.cpp	(revision 2802)
+++ trunk/src/user32/win32wmdichild.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: win32wmdichild.cpp,v 1.21 2000-02-05 14:08:54 sandervl Exp $ */
+/* $Id: win32wmdichild.cpp,v 1.22 2000-02-16 14:28:24 sandervl Exp $ */
 /*
  * Win32 MDI Child Window Class for OS/2
@@ -41,4 +41,6 @@
 #include "win32wndhandle.h"
 
+#define DBG_LOCALLOG	DBG_win32wmdichild
+#include "dbglocal.h"
 
 //******************************************************************************
Index: trunk/src/user32/win32wmdiclient.cpp
===================================================================
--- trunk/src/user32/win32wmdiclient.cpp	(revision 2802)
+++ trunk/src/user32/win32wmdiclient.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: win32wmdiclient.cpp,v 1.23 2000-01-18 20:11:00 sandervl Exp $ */
+/* $Id: win32wmdiclient.cpp,v 1.24 2000-02-16 14:28:24 sandervl Exp $ */
 /*
  * Win32 MDI Client Window Class for OS/2
@@ -36,4 +36,7 @@
 #include "win32wndhandle.h"
 
+#define DBG_LOCALLOG	DBG_win32wmdiclient
+#include "dbglocal.h"
+
 
 //******************************************************************************
Index: trunk/src/user32/win32wnd.cpp
===================================================================
--- trunk/src/user32/win32wnd.cpp	(revision 2802)
+++ trunk/src/user32/win32wnd.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: win32wnd.cpp,v 1.7 2000-01-18 20:11:01 sandervl Exp $ */
+/* $Id: win32wnd.cpp,v 1.8 2000-02-16 14:28:24 sandervl Exp $ */
 /*
  * Win32 Window Class for OS/2
@@ -36,4 +36,6 @@
 #include "win32wmdiclient.h"
 
+#define DBG_LOCALLOG	DBG_win32wnd
+#include "dbglocal.h"
 
 //******************************************************************************
Index: trunk/src/user32/win32wndchild.cpp
===================================================================
--- trunk/src/user32/win32wndchild.cpp	(revision 2802)
+++ trunk/src/user32/win32wndchild.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: win32wndchild.cpp,v 1.4 2000-01-18 20:11:01 sandervl Exp $ */
+/* $Id: win32wndchild.cpp,v 1.5 2000-02-16 14:28:25 sandervl Exp $ */
 /*
  * Win32 Child/Parent window class for OS/2
@@ -13,4 +13,7 @@
 #include <win32wndchild.h>
 #include <misc.h>
+
+#define DBG_LOCALLOG	DBG_win32wndchild
+#include "dbglocal.h"
 
 //******************************************************************************
Index: trunk/src/user32/win32wndhandle.cpp
===================================================================
--- trunk/src/user32/win32wndhandle.cpp	(revision 2802)
+++ trunk/src/user32/win32wndhandle.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: win32wndhandle.cpp,v 1.4 2000-01-18 20:11:03 sandervl Exp $ */
+/* $Id: win32wndhandle.cpp,v 1.5 2000-02-16 14:28:25 sandervl Exp $ */
 /*
  * Win32 Handle Management Code for OS/2
@@ -19,4 +19,7 @@
 #include <vmutex.h>
 #include "win32wndhandle.h"
+
+#define DBG_LOCALLOG	DBG_win32wndhandle
+#include "dbglocal.h"
 
 //******************************************************************************
Index: trunk/src/user32/winaccel.cpp
===================================================================
--- trunk/src/user32/winaccel.cpp	(revision 2802)
+++ trunk/src/user32/winaccel.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: winaccel.cpp,v 1.5 2000-01-18 20:11:04 sandervl Exp $ */
+/* $Id: winaccel.cpp,v 1.6 2000-02-16 14:28:25 sandervl Exp $ */
 /*
  * Win32 accelerator key functions for OS/2
@@ -13,4 +13,7 @@
 #include <win32wbase.h>
 #include <winaccel.h>
+
+#define DBG_LOCALLOG	DBG_winaccel
+#include "dbglocal.h"
 
 /*****************************************************************************
Index: trunk/src/user32/windlg.cpp
===================================================================
--- trunk/src/user32/windlg.cpp	(revision 2802)
+++ trunk/src/user32/windlg.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: windlg.cpp,v 1.15 2000-02-06 17:39:35 cbratschi Exp $ */
+/* $Id: windlg.cpp,v 1.16 2000-02-16 14:28:25 sandervl Exp $ */
 /*
  * Win32 dialog apis for OS/2
@@ -26,4 +26,7 @@
 #include <win\drive.h>
 
+#define DBG_LOCALLOG	DBG_windlg
+#include "dbglocal.h"
+
 static INT  DIALOG_DlgDirListW( HWND hDlg, LPWSTR spec, INT idLBox, INT idStatic, UINT attrib, BOOL combo );
 static INT  DIALOG_DlgDirList( HWND hDlg, LPSTR spec, INT idLBox, INT idStatic, UINT attrib, BOOL combo );
Index: trunk/src/user32/windlgmsg.cpp
===================================================================
--- trunk/src/user32/windlgmsg.cpp	(revision 2802)
+++ trunk/src/user32/windlgmsg.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: windlgmsg.cpp,v 1.5 2000-01-18 20:11:07 sandervl Exp $ */
+/* $Id: windlgmsg.cpp,v 1.6 2000-02-16 14:28:25 sandervl Exp $ */
 /*
  * Win32 dialog message APIs for OS/2
@@ -20,4 +20,7 @@
 #include "win32wbase.h"
 #include "win32dlg.h"
+
+#define DBG_LOCALLOG	DBG_windlgmsg
+#include "dbglocal.h"
 
 //******************************************************************************
Index: trunk/src/user32/window.cpp
===================================================================
--- trunk/src/user32/window.cpp	(revision 2802)
+++ trunk/src/user32/window.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: window.cpp,v 1.54 2000-01-29 14:23:33 sandervl Exp $ */
+/* $Id: window.cpp,v 1.55 2000-02-16 14:28:26 sandervl Exp $ */
 /*
  * Win32 window apis for OS/2
@@ -31,4 +31,7 @@
 #include "winicon.h"
 #include <win\winpos.h>
+
+#define DBG_LOCALLOG	DBG_window
+#include "dbglocal.h"
 
 //******************************************************************************
Index: trunk/src/user32/windowclass.cpp
===================================================================
--- trunk/src/user32/windowclass.cpp	(revision 2802)
+++ trunk/src/user32/windowclass.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: windowclass.cpp,v 1.8 2000-01-18 20:11:09 sandervl Exp $ */
+/* $Id: windowclass.cpp,v 1.9 2000-02-16 14:28:26 sandervl Exp $ */
 /*
  * Win32 Window Class Code for OS/2
@@ -20,4 +20,7 @@
 #include <win32wbase.h>
 #include <controls.h>
+
+#define DBG_LOCALLOG	DBG_windowclass
+#include "dbglocal.h"
 
 //******************************************************************************
Index: trunk/src/user32/windowmsg.cpp
===================================================================
--- trunk/src/user32/windowmsg.cpp	(revision 2802)
+++ trunk/src/user32/windowmsg.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: windowmsg.cpp,v 1.18 2000-01-30 18:48:29 sandervl Exp $ */
+/* $Id: windowmsg.cpp,v 1.19 2000-02-16 14:28:26 sandervl Exp $ */
 /*
  * Win32 window message APIs for OS/2
@@ -24,4 +24,7 @@
 #include "oslibwin.h"
 #include "oslibmsg.h"
+
+#define DBG_LOCALLOG	DBG_windowmsg
+#include "dbglocal.h"
 
 //******************************************************************************
Index: trunk/src/user32/windowword.cpp
===================================================================
--- trunk/src/user32/windowword.cpp	(revision 2802)
+++ trunk/src/user32/windowword.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: windowword.cpp,v 1.7 2000-01-18 20:11:12 sandervl Exp $ */
+/* $Id: windowword.cpp,v 1.8 2000-02-16 14:28:27 sandervl Exp $ */
 
 /*
@@ -14,4 +14,7 @@
 
 #include <win32wbase.h>
+
+#define DBG_LOCALLOG	DBG_windowword
+#include "dbglocal.h"
 
 //******************************************************************************
Index: trunk/src/user32/wingdi.cpp
===================================================================
--- trunk/src/user32/wingdi.cpp	(revision 2802)
+++ trunk/src/user32/wingdi.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: wingdi.cpp,v 1.5 2000-01-18 20:11:12 sandervl Exp $ */
+/* $Id: wingdi.cpp,v 1.6 2000-02-16 14:28:27 sandervl Exp $ */
 /*
  * Win32 Window graphics apis for OS/2
@@ -17,4 +17,7 @@
 #include <oslibwin.h>
 #include <oslibgdi.h>
+
+#define DBG_LOCALLOG	DBG_wingdi
+#include "dbglocal.h"
 
 #define OPEN32_GDI
Index: trunk/src/user32/winicon.cpp
===================================================================
--- trunk/src/user32/winicon.cpp	(revision 2802)
+++ trunk/src/user32/winicon.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: winicon.cpp,v 1.8 2000-01-18 20:11:15 sandervl Exp $ */
+/* $Id: winicon.cpp,v 1.9 2000-02-16 14:28:27 sandervl Exp $ */
 /*
  * Win32 Icon Code for OS/2
@@ -21,4 +21,7 @@
 #include <winicon.h>
 #include <win\cursoricon.h>
+
+#define DBG_LOCALLOG	DBG_winicon
+#include "dbglocal.h"
 
 //******************************************************************************
Index: trunk/src/user32/winkeyboard.cpp
===================================================================
--- trunk/src/user32/winkeyboard.cpp	(revision 2802)
+++ trunk/src/user32/winkeyboard.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: winkeyboard.cpp,v 1.4 2000-01-18 20:11:16 sandervl Exp $ */
+/* $Id: winkeyboard.cpp,v 1.5 2000-02-16 14:28:27 sandervl Exp $ */
 /*
  * Win32 <-> PM key translation
@@ -14,4 +14,7 @@
 #include "oslibwin.h"
 #include <heapstring.h>
+
+#define DBG_LOCALLOG	DBG_winkeyboard
+#include "dbglocal.h"
 
 BYTE abPMScanToWinVKey[256] =
Index: trunk/src/user32/winmouse.cpp
===================================================================
--- trunk/src/user32/winmouse.cpp	(revision 2802)
+++ trunk/src/user32/winmouse.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: winmouse.cpp,v 1.4 2000-01-18 20:11:19 sandervl Exp $ */
+/* $Id: winmouse.cpp,v 1.5 2000-02-16 14:28:28 sandervl Exp $ */
 /*
  * Mouse handler for DINPUT
@@ -15,4 +15,7 @@
 #include "oslibmsg.h"
 #include "pmwindow.h"
+
+#define DBG_LOCALLOG	DBG_winmouse
+#include "dbglocal.h"
 
 LPMOUSE_EVENT_PROC mouseHandler = NULL;
Index: trunk/src/user32/winproc.cpp
===================================================================
--- trunk/src/user32/winproc.cpp	(revision 2802)
+++ trunk/src/user32/winproc.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: winproc.cpp,v 1.3 2000-01-18 20:11:21 sandervl Exp $ */
+/* $Id: winproc.cpp,v 1.4 2000-02-16 14:28:28 sandervl Exp $ */
 /*
  * Window procedure callbacks
@@ -21,4 +21,7 @@
 #include <heapcode.h>
 #include "win32wbase.h"
+
+#define DBG_LOCALLOG	DBG_winproc
+#include "dbglocal.h"
 
 DECLARE_DEBUG_CHANNEL(relay)
Index: trunk/src/user32/winprop.cpp
===================================================================
--- trunk/src/user32/winprop.cpp	(revision 2802)
+++ trunk/src/user32/winprop.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: winprop.cpp,v 1.6 2000-01-18 20:11:22 sandervl Exp $ */
+/* $Id: winprop.cpp,v 1.7 2000-02-16 14:28:28 sandervl Exp $ */
 /*
  * Win32 Property apis for OS/2
@@ -13,4 +13,7 @@
 #include <misc.h>
 #include "win32wbase.h"
+
+#define DBG_LOCALLOG	DBG_winprop
+#include "dbglocal.h"
 
 #undef DEBUG
Index: trunk/src/user32/winswitch.cpp
===================================================================
--- trunk/src/user32/winswitch.cpp	(revision 2802)
+++ trunk/src/user32/winswitch.cpp	(revision 2803)
@@ -1,3 +1,3 @@
-/* $Id: winswitch.cpp,v 1.3 2000-01-18 20:11:24 sandervl Exp $ */
+/* $Id: winswitch.cpp,v 1.4 2000-02-16 14:28:28 sandervl Exp $ */
 /*
  * WinSwitch control
@@ -14,4 +14,7 @@
 #include "controls.h"
 #include "winswitch.h"
+
+#define DBG_LOCALLOG	DBG_winswitch
+#include "dbglocal.h"
 
 LRESULT WINAPI WinSwitchWndProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam)